;**************************************************************
;***    XMS0A.ASM                                           ***
;***                                                        ***
;***    function        XMS_XmBlk.freeXM                    ***
;***                        : Boolean                       ***
;***                                                        ***
;***    Frees an exteded memory block referred to by        ***
;***    handle.                                             ***
;***                                                        ***
;**************************************************************

        .model  large,pascal 

        include xmsdefs.asm 

        extrn   errno:WORD  
        extrn   xmsHandler:DWord

;
;   Define entry point
;
        public  XMS_XmBlk@freeXM

        .code

XMS_XmBlk@freeXM    proc    handle:Far Ptr Word

        les     bx,handle
        mov     dx,es:[bx]          ; get the block's handle
        mov     ah,XMSFreeXM        ; Function code
        call    xmsHandler          ; call the guy

        or      ax,ax               ; AX=0 means error
        jz      errorReturn

        mov     ax,XMSErrOK         ; No error
        ret

errorReturn:
        mov     al,bl               ; Move error code to AL
        xor     ah,ah               ; Zero extend to 16 bits
        mov     errno,ax            ; Copy to errno
        ret

XMS_XmBlk@freeXM    endp            ; end of procedure

        end
